#pragma once

#include "Settings.h"
#define MAX_INI_FILE_SIZE 128000

class CLogAnalysisSettings : public CSettings
{
protected:
	bool ReadFromFileINI(LPCTSTR fn);
	bool WriteToFileINI(LPCTSTR fn);
	bool WriteToFileXML(LPCTSTR fn);

public:
	void LoadDefaults();
	bool ParseXML(CString& key, CString& val);
	CString ToXML();

	virtual bool IsAllowedByFilters(CString& Line);

	//general
	class GeneralParameters{
	public:
		int SortedColumn;
		CString EOL;
		CString Separator;
		bool Trim;
		bool FirstLineHeader;
	}General;

	//filters
	class FilterParameters{
	public:
		int MaxEntries;
		CStringList Include;
		CStringList Exclude;
	}Filter;

	CLogAnalysisSettings(void);
	virtual ~CLogAnalysisSettings(void);
};
