#include "stdafx.h"
#include "LogViewDetails.h"
#include "StringHelper.h"

IMPLEMENT_DYNCREATE(CLogViewDetails, CView)

CLogViewDetails::CLogViewDetails(void)
{
}

CLogViewDetails::~CLogViewDetails(void)
{
}

BOOL CLogViewDetails::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CsplitterbasicView drawing

void CLogViewDetails::OnDraw(CDC* /*pDC*/)
{
	//CsplitterbasicDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);
	//if (!pDoc)
	//	return;

	// TODO: add draw code for native data here

}


// CsplitterbasicView printing

BOOL CLogViewDetails::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CLogViewDetails::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CLogViewDetails::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CLogViewDetails::SetDetailView(LPCTSTR Text, LPCTSTR Separator, int ColumnCount)
{
	CStringList Fields;
	CStringHelper::Split(Fields,Text,Separator,0);
	SetDetailView(Fields,ColumnCount);
}

void CLogViewDetails::SetDetailView(CStringList &Fields, int ColumnCount)
{
	//try{

		int poscolon(-1);
		CString crlf("\r\n");
		POSITION pos;
		int count(0);

		CHARFORMAT cfNormal;
		cfNormal.cbSize = sizeof(cfNormal);
		cfNormal.dwMask = CFM_BOLD | CFM_COLOR;
		cfNormal.dwEffects = CFE_AUTOCOLOR;
		//cfNormal.crTextColor = 0xFFFFFFFF;

		CHARFORMAT cfHeader;
		cfHeader.cbSize = sizeof(cfHeader);
		cfHeader.dwMask = CFM_BOLD;
		cfHeader.dwEffects = CFE_BOLD;
		//cfHeader.crTextColor = 0x00FF0000;

		CHARFORMAT cfMessage;
		cfMessage.cbSize = sizeof(cfMessage);
		cfMessage.dwMask = CFM_BOLD | CFM_COLOR;
		cfMessage.dwEffects = CFE_BOLD;
		cfMessage.crTextColor = 0x000000FF;

		CString fld("");
		CString fldleft("");
		CString fldleftupper("");
		pos = Fields.GetHeadPosition();
		details.SetWindowText("");
		details.SetRedraw(FALSE);
		//UNDOdetails.SetSelectionCharFormat(cfnormal);
		while(pos!=NULL){
			fld = Fields.GetNext(pos);
			poscolon =fld.Find(':');

			if(poscolon==-1){
				AppendDetailView(fld+crlf);
			}else{
				fldleft = fld.Left(poscolon);
				fldleftupper = fldleft;
				fldleftupper.MakeUpper();
				if(count<ColumnCount || (fldleft.Find(' ')==-1 && fldleft.GetLength()>2 && fldleft==fldleftupper) ){
					//before colon
					details.SetSel(details.GetWindowTextLength(),-1);
					if(count<ColumnCount){
						details.SetSelectionCharFormat(cfHeader);
					}else{
						details.SetSelectionCharFormat(cfMessage);
					}
					details.ReplaceSel(fldleft,FALSE);

					//after colon
					details.SetSel(details.GetWindowTextLength(),-1);
					details.SetSelectionCharFormat(cfNormal);
					details.ReplaceSel(fld.Mid(poscolon)+crlf);
				}else{
					AppendDetailView(fld+crlf);
				}
			}
			count++;
		}
		details.SetRedraw(TRUE);
		details.RedrawWindow();

		/*
	}catch(...){
		Error("Fatal error setting detail window");
	}//*/
}

inline void CLogViewDetails::AppendDetailView(LPCTSTR Text)
{
	details.SetSel(details.GetWindowTextLength(),-1);
	details.ReplaceSel(Text,FALSE);
}

void CLogViewDetails::Clear()
{
	SetDetailView("","",0);
}

CString CLogViewDetails::GetSelText()
{
	return details.GetSelText();
}
BEGIN_MESSAGE_MAP(CLogViewDetails, CView)
	ON_WM_CREATE()
	ON_WM_SIZE()
END_MESSAGE_MAP()

int CLogViewDetails::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	//Add your specialized creation code here

	
	//rich edit lib
	if (!AfxInitRichEdit())
		return -1;


	//set font
	LOGFONT logfont;
	logfont.lfHeight = 14;
	logfont.lfWidth = 0;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = FW_NORMAL;
	logfont.lfItalic = FALSE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(logfont.lfFaceName,"Verdana");
	font.CreateFontIndirect(&logfont);


	//details
	CRect cr;
	GetClientRect(&cr);
	if (!details.Create(WS_BORDER|WS_HSCROLL|WS_VSCROLL|WS_CHILD|WS_VISIBLE|WS_TABSTOP|ES_AUTOHSCROLL|ES_AUTOVSCROLL|ES_MULTILINE|ES_NOHIDESEL|ES_WANTRETURN,cr,this,NULL)){
		return -1;
	}else{
		details.SetFont(&font);
		details.SetOptions(ECOOP_OR,ECO_AUTOWORDSELECTION|ECO_SAVESEL);
		//details.SetReadOnly();
		//RegisterClipboardFormat(CF_RTF);
		//details.SetOLECallback();
	}

	return 0;
}

void CLogViewDetails::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	//Add your message handler code here
	CRect cr;
	GetClientRect(&cr);
	details.MoveWindow(&cr);
}

BOOL CLogViewDetails::CanUndo()
{
	return details.CanUndo();
}

void CLogViewDetails::Undo()
{
	details.Undo();
}

BOOL CLogViewDetails::CanRedo()
{
	return details.CanRedo();
}

void CLogViewDetails::Redo()
{
	details.Redo();
}

void CLogViewDetails::Cut()
{
	details.Cut();
}

void CLogViewDetails::Copy()
{
	details.Copy();
}

void CLogViewDetails::Paste()
{
	details.Paste();
}
